/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      ...
 *   Co-authors:
 *      ...
 *
 */

#include "Answer.h"
#include "core/CoreIncludes.h"


namespace orxonox{

    RegisterClass(Answer);


    // Constructor:
    Answer::Answer(Context* context) : BaseObject(context)
    {
        RegisterObject(Answer);
    }

    void Answer::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(Answer, XMLPort, xmlelement, mode);

        XMLPortParam(Answer, "Id", setAnswerId, getAnswerId, xmlelement, mode);
        XMLPortParam(Answer, "answer", setAnswer, getAnswer, xmlelement, mode);
        XMLPortParam(Answer, "nextQuestionId", setNextQuestion, getNextQuestion, xmlelement,mode);
    }

    void Answer::setAnswerId(const std::string& answerId){
        this->answerId_ = answerId;
    }

    const std::string& Answer::getAnswerId() const
    {
        return this->answerId_;
    }

    void Answer::setNextQuestion(const std::string& nextId)
    {
        this->nextQuestionId_ = nextId;
    }

    const std::string& Answer::getNextQuestion() const
    {
        return this->nextQuestionId_;
    }

    void Answer::setAnswer(const std::string& answer)
    {
        this->answer_ = answer;
    }

    const std::string& Answer::getAnswer() const
    {
        return this->answer_;
    }
}
